function vexpower.panel_text()
	return {
		type = "group",
		order= 3,
		args = {
			grpleft = {
				name = "Left text",
				order=1, type ="group", dialogInline = true,
				args = {
					framelefttextcontent = {
						name = "Text",
						desc = "Text that is shown left",
						order=2, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["text"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["text"] end
						},
					framelefttexttags = {name = "You can use the following tags to parse information:\n{CurrentEnergy} {MaxEnergy} {PercEnergy} {CurrentCPs} {MaxCPs}", type="description", order=3},
					framelefttextfont = {
						name = "Font",
						order=5, type = "select",
						dialogControl = "LSM30_Font",
						values = vexpower.LSM:HashTable("font"),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["left"]["font"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["font"] end,
						},
					framelefttextsize = {
						name = "Size",
						order=6, type = "range",
						step = 1, min = 6, max = 20,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["size"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["size"] end,
						},
					framelefttextfontalign = {
						name = "Text align",
						order=7, type = "select", style = "dropdown",
						desc = "Sets the text align",
						values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["left"]["align"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["align"] end,
						},
					framelefttextcolor = {
						name = "color",
						order=8, type = "color", hasAlpha=true, width="full",
						desc = "Sets the text color",
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["b"]=b
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["a"]=a
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["b"],
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["a"] end,
						},
					framelefttextwidth = {
						name = "Width",
						order=10, type = "range",
						step = 1, min = 1, max = 400,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["width"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["width"] end
						},
					framelefttextx = {
						name = "X Position",
						order=11, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["x"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["x"] end
						},
					framelefttexty = {
						name = "Y Position",
						order=12, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["y"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["y"] end
						},
					},
				},
			frame_space1 = {name ="\n", type = "description", order=2},
			
			
			grpright = {
				name = "Right text",
				order=3, type ="group", dialogInline = true,
				args = {
					framerighttextcontent = {
						name = "text",
						desc = "text that is shown right",
						order=102, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["text"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["text"] end
						},
					framerighttexttags = {name = "You can use the following tags to parse information:\n{CurrentEnergy} {MaxEnergy} {PercEnergy} {CurrentCPs} {MaxCPs}", type="description", order=103},
					framerighttextfont = {
						name = "font",
						order=105, type = "select",
						dialogControl = "LSM30_Font",
						values = vexpower.LSM:HashTable("font"),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["right"]["font"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["font"] end,
						},
					framerighttextsize = {
						name = "Size",
						order=106, type = "range",
						step = 1, min = 6, max = 20,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["size"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["size"] end,
						},
					framerighttextfontalign = {
						name = "Text align",
						order=107, type = "select", style = "dropdown",
						desc = "Sets the text align",
						values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["right"]["align"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["align"] end,
						},
					framerighttextcolor = {
						name = "color",
						order=108, type = "color", hasAlpha=true, width="full",
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["b"]=b
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["a"]=a
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["b"],
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["a"] end,
						},
					framerighttextwidth = {
						name = "Width",
						order=110, type = "range",
						step = 1, min = 1, max = 400,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["width"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["width"] end
						},
					framerighttextx = {
						name = "X-Position",
						order=111, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["x"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["x"] end
						},
					framerighttexty = {
						name = "Y-Position",
						order=112, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["y"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["y"] end
						},
					},
				},
			}
		}
end